Package org.springframework.beans.factory.config

# Class FieldRetrievingFactoryBean

java.lang.Object
org.springframework.beans.factory.config.FieldRetrievingFactoryBean

All Implemented Interfaces:
  `Aware`, `BeanClassLoaderAware`, `BeanNameAware`, `FactoryBean<Object>`, `InitializingBean`

public class FieldRetrievingFactoryBean extends Object implements FactoryBean<Object>, BeanNameAware, BeanClassLoaderAware, InitializingBean
`FactoryBean` which retrieves a static or non-static field value.

Typically used for retrieving public static final constants. Usage example:

     // standard definition for exposing a static field, specifying the "staticField" property
     <bean id="myField" class="org.springframework.beans.factory.config.FieldRetrievingFactoryBean">
       <property name="staticField" value="java.sql.Connection.TRANSACTION_SERIALIZABLE"/>
     </bean>

     // convenience version that specifies a static field pattern as bean name
     <bean id="java.sql.Connection.TRANSACTION_SERIALIZABLE"
           class="org.springframework.beans.factory.config.FieldRetrievingFactoryBean"/>

If you are using Spring 2.0, you can also use the following style of configuration for public static fields.

    <util:constant static-field="java.sql.Connection.TRANSACTION_SERIALIZABLE"/>

Since:
  1.1
Author:
  Juergen Hoeller
See Also:
  - `setStaticField(java.lang.String)`

## Field Summary

### Fields inherited from interface org.springframework.beans.factory.FactoryBean

`OBJECT_TYPE_ATTRIBUTE`

## Constructor Summary

Constructors
Constructor
Description
`FieldRetrievingFactoryBean()`

## Method Summary

Modifier and Type
Method
Description
`void`
`afterPropertiesSet()`
Invoked by the containing `BeanFactory` after it has set all bean properties and satisfied `BeanFactoryAware`, `ApplicationContextAware` etc.
`Object`
`getObject()`
Return an instance (possibly shared or independent) of the object managed by this factory.
`Class<?>`
`getObjectType()`
Return the type of object that this FactoryBean creates, or `null` if not known in advance.
`Class<?>`
`getTargetClass()`
Return the target class on which the field is defined.
`String`
`getTargetField()`
Return the name of the field to be retrieved.
`Object`
`getTargetObject()`
Return the target object on which the field is defined.
`boolean`
`isSingleton()`
Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?
`void`
`setBeanClassLoader(ClassLoader classLoader)`
Callback that supplies the bean `class loader` to a bean instance.
`void`
`setBeanName(String beanName)`
The bean name of this FieldRetrievingFactoryBean will be interpreted as "staticField" pattern, if neither "targetClass" nor "targetObject" nor "targetField" have been specified.
`void`
`setStaticField(String staticField)`
Set a fully qualified static field name to retrieve, for example, "example.MyExampleClass.MY_EXAMPLE_FIELD".
`void`
`setTargetClass(Class<?> targetClass)`
Set the target class on which the field is defined.
`void`
`setTargetField(String targetField)`
Set the name of the field to be retrieved.
`void`
`setTargetObject(Object targetObject)`
Set the target object on which the field is defined.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### FieldRetrievingFactoryBean

public FieldRetrievingFactoryBean()

## Method Details

### setTargetClass

public void setTargetClass(@Nullable Class<?> targetClass)
Set the target class on which the field is defined. Only necessary when the target field is static; else, a target object needs to be specified anyway.

See Also:
  - `setTargetObject(java.lang.Object)`
  - `setTargetField(java.lang.String)`

### getTargetClass

@Nullable public Class<?> getTargetClass()
Return the target class on which the field is defined.

### setTargetObject

public void setTargetObject(@Nullable Object targetObject)
Set the target object on which the field is defined. Only necessary when the target field is not static; else, a target class is sufficient.

See Also:
  - `setTargetClass(java.lang.Class<?>)`
  - `setTargetField(java.lang.String)`

### getTargetObject

@Nullable public Object getTargetObject()
Return the target object on which the field is defined.

### setTargetField

public void setTargetField(@Nullable String targetField)
Set the name of the field to be retrieved. Refers to either a static field or a non-static field, depending on a target object being set.

See Also:
  - `setTargetClass(java.lang.Class<?>)`
  - `setTargetObject(java.lang.Object)`

### getTargetField

@Nullable public String getTargetField()
Return the name of the field to be retrieved.

### setStaticField

public void setStaticField(String staticField)
Set a fully qualified static field name to retrieve, for example, "example.MyExampleClass.MY_EXAMPLE_FIELD". Convenient alternative to specifying targetClass and targetField.

See Also:
  - `setTargetClass(java.lang.Class<?>)`
  - `setTargetField(java.lang.String)`

### setBeanName

public void setBeanName(String beanName)
The bean name of this FieldRetrievingFactoryBean will be interpreted as "staticField" pattern, if neither "targetClass" nor "targetObject" nor "targetField" have been specified. This allows for concise bean definitions with just an id/name.

Specified by:
  `setBeanName` in interface `BeanNameAware`
Parameters:
  `beanName` - the name of the bean in the factory. Note that this name is the actual bean name used in the factory, which may differ from the originally specified name: in particular for inner bean names, the actual bean name might have been made unique through appending "#..." suffixes. Use the `BeanFactoryUtils.originalBeanName(String)` method to extract the original bean name (without suffix), if desired.

### setBeanClassLoader

public void setBeanClassLoader(ClassLoader classLoader)
Description copied from interface: `BeanClassLoaderAware`
Callback that supplies the bean `class loader` to a bean instance.

Invoked after the population of normal bean properties but before an initialization callback such as `InitializingBean's` `InitializingBean.afterPropertiesSet()` method or a custom init-method.

Specified by:
  `setBeanClassLoader` in interface `BeanClassLoaderAware`
Parameters:
  `classLoader` - the owning class loader

### afterPropertiesSet

public void afterPropertiesSet() throws ClassNotFoundException, NoSuchFieldException
Description copied from interface: `InitializingBean`
Invoked by the containing `BeanFactory` after it has set all bean properties and satisfied `BeanFactoryAware`, `ApplicationContextAware` etc.

This method allows the bean instance to perform validation of its overall configuration and final initialization when all bean properties have been set.

Specified by:
  `afterPropertiesSet` in interface `InitializingBean`
Throws:
  `ClassNotFoundException`
  `NoSuchFieldException`

### getObject

@Nullable public Object getObject() throws IllegalAccessException
Description copied from interface: `FactoryBean`
Return an instance (possibly shared or independent) of the object managed by this factory.

As with a `BeanFactory`, this allows support for both the Singleton and Prototype design patterns.

If this FactoryBean is not fully initialized yet at the time of the call (for example because it is involved in a circular reference), throw a corresponding `FactoryBeanNotInitializedException`.

FactoryBeans are allowed to return `null` objects. The bean factory will consider this as a normal value to be used and will not throw a `FactoryBeanNotInitializedException` in this case. However, FactoryBean implementations are encouraged to throw `FactoryBeanNotInitializedException` themselves, as appropriate.

Specified by:
  `getObject` in interface `FactoryBean<Object>`
Returns:
  an instance of the bean (can be `null`)
Throws:
  `IllegalAccessException`
See Also:
  - `FactoryBeanNotInitializedException`

### getObjectType

@Nullable public Class<?> getObjectType()
Description copied from interface: `FactoryBean`
Return the type of object that this FactoryBean creates, or `null` if not known in advance.

This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

In the case of implementations that create a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore, it is highly recommended to implement this method properly, using the current state of the FactoryBean.

Specified by:
  `getObjectType` in interface `FactoryBean<Object>`
Returns:
  the type of object that this FactoryBean creates, or `null` if not known at the time of the call
See Also:
  - `ListableBeanFactory.getBeansOfType(java.lang.Class<T>)`

### isSingleton

public boolean isSingleton()
Description copied from interface: `FactoryBean`
Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

NOTE: If a FactoryBean indicates that it holds a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

The default implementation returns `true`, since a `FactoryBean` typically manages a singleton instance.

Specified by:
  `isSingleton` in interface `FactoryBean<Object>`
Returns:
  whether the exposed object is a singleton
See Also:
  - `FactoryBean.getObject()`
  - `SmartFactoryBean.isPrototype()`